<?php

namespace Paheko;

use Paheko\Plugin\RecusFiscaux\Personne;
use Paheko\Plugin\RecusFiscaux\Utils;

// ------------------------------------------------------------
// récupérer les infos du formulaire
// ------------------------------------------------------------

// vérifier qu'on a bien sélectionné une activité ou un compte
if (! isset($_SESSION['tauxSelectionnes'])
    &&
    null === f('tarifs')
    &&
    null === f('comptes'))
{
    \Paheko\Utils::redirect(\Paheko\Utils::plugin_url() . 'index.php');
}

// tarifs sélectionnés
if (null !== f('tarifs')) {
    $tarifsSelectionnes = f('tarifs');
} else if (! isset($_SESSION['tauxSelectionnes'])) {
    $tarifsSelectionnes = [];
}
// error_log("\ntarifsSelectionnes=" . print_r($tarifsSelectionnes, true));
// comptes sélectionnés
if (null !== f('comptes')) {
    $_SESSION['comptesSelectionnes'] = f('comptes');
    //     error_log("\ncomptesSelectionnes=" . print_r($_SESSION['comptesSelectionnes'], true));
} /*
else if (! isset($_SESSION['tauxSelectionnes'])) {
    $_SESSION['comptesSelectionnes'] = [];
}
  */

// taux de réduction associés
$tauxSelectionnes = array();
if (isset($tarifsSelectionnes))
{
    foreach ($tarifsSelectionnes as $idTarif)
    {
        $nomRadio = "taux_reduction_" . $idTarif;
        $tauxSelectionnes[$idTarif] = f("$nomRadio");
    }
}
if (isset($_SESSION['comptesSelectionnes']))
{
    foreach ($_SESSION['comptesSelectionnes'] as $idCompte)
    {
        $nomRadio = "taux_reduction_" . $idCompte;
        $tauxSelectionnes[$idCompte] = f("$nomRadio");
    }
}
$_SESSION['tauxSelectionnes'] = $tauxSelectionnes;

$lesTarifs = array_map(fn($elem) : string =>
                       strpos($elem, '_') !== false ? substr($elem, 0, strpos($elem, '_')) : "",
                       $tarifsSelectionnes);
$lesComptes = array_map(fn($elem) : string =>
                        strpos($elem, '_') !== false ? substr($elem, 1 + strpos($elem, '_')) : "",
                        $tarifsSelectionnes);

# versements des tarifs sélectionnées et de leur compte associé
if (count($lesTarifs) != 0)
{
    $_SESSION['lesVersements'] =
                           Utils::getVersementsTarifsComptes(
                               $_SESSION['annee_recu'],
                               $lesTarifs,
                               $lesComptes,
                               $champsNom);
    //    error_log("lesVersements=" . print_r($_SESSION['lesVersements'], true));
}

// ajouter les versements sans tarif (tri par nom, compte, date)
if (isset($_SESSION['comptesSelectionnes']))
{
    $versementsSansTarif = Utils::getVersementsComptes($_SESSION['annee_recu'],
                                                       $_SESSION['comptesSelectionnes'],
                                                       $champsNom);
    foreach ($versementsSansTarif as $versement)
    {
        $_SESSION['lesVersements'][] = $versement;
    }
}
//error_log("lesVersements=" . print_r($_SESSION['lesVersements'], true));

// préparation de l'affichage
$tpl->assign('lesVersements', $_SESSION['lesVersements']);
$tpl->assign('annee_recu', $_SESSION['annee_recu']);
$tpl->assign('plugin_css', ['style.css']);

// envoyer au template
$tpl->display(PLUGIN_ROOT . '/templates/versements_activites.tpl');

